import React, { useEffect } from "react";
function createSwagger(schema, plugins) {
    return import("swagger-ui-dist").then(swagger => {
        const presets = [swagger.SwaggerUIBundle.presets.apis, plugins];
        // temporary any type, because some fucking idiot added not correct types to @types/swagger-ui-dist package
        const ui = swagger.SwaggerUIBundle({
            dom_id: "#swagger",
            spec: schema,
            presets,
            requestInterceptor: (req) => {
                const bearer = localStorage.getItem("bearer");
                req.headers = {
                    ...req.headers,
                    Authorization: bearer,
                };
                return req;
            },
        });
        return ui;
    });
}
function prepareDataForCreate(schema, url) {
    if (url) {
        schema = { ...schema, host: url };
    }
    return schema;
}
export const OpenApiRenderEngine = ({ source, options = {} }) => {
    useEffect(() => {
        const create = async () => {
            await createSwagger(prepareDataForCreate(source.content || source.rawContent, (source.data && source.data.url) || options.schemaUrl), options.plugins);
        };
        create();
    }, [source, options]);
    return React.createElement("div", { id: "swagger" });
};
